#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityFishingCeleLotteryMap.h"
std::auto_ptr<M_ActivityFishingCeleLotteryMap> M_ActivityFishingCeleLotteryMap::msSingleton(nullptr);

int M_ActivityFishingCeleLotteryMap::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityFishingCeleLotteryMapData* M_ActivityFishingCeleLotteryMap::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityFishingCeleLotteryMapData>& M_ActivityFishingCeleLotteryMap::GetMapData()
{
	return mMapData;
}

void M_ActivityFishingCeleLotteryMap::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityFishingCeleLotteryMap.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityFishingCeleLotteryMapData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* Weight = element->Attribute("Weight");
			std::vector<std::string> vecWeight;
			boost::split(vecWeight, Weight, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecWeight.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecWeight[i].c_str(), &temp))
				{
					data.mWeight.push_back(temp);
				}
			}
		}
		{
			const char* ItemId = element->Attribute("ItemId");
			std::vector<std::string> vecItemId;
			boost::split(vecItemId, ItemId, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemId.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemId[i].c_str(), &temp))
				{
					data.mItemId.push_back(temp);
				}
			}
		}
		{
			const char* ItemCount = element->Attribute("ItemCount");
			std::vector<std::string> vecItemCount;
			boost::split(vecItemCount, ItemCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemCount[i].c_str(), &temp))
				{
					data.mItemCount.push_back(temp);
				}
			}
		}
		{
			const char* WeightShow = element->Attribute("WeightShow");
			std::vector<std::string> vecWeightShow;
			boost::split(vecWeightShow, WeightShow, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecWeightShow.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecWeightShow[i].c_str(), &temp))
				{
					data.mWeightShow.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityFishingCeleLotteryMap Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleLotteryMap::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityFishingCeleLotteryMap");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityFishingCeleLotteryMap");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityFishingCeleLotteryMapData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "Weight", data.mWeight);
		LuaCfgHelper::readVectorInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readVectorInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readVectorInt(L, "WeightShow", data.mWeightShow);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityFishingCeleLotteryMap Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityFishingCeleLotteryMap::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityFishingCeleLotteryMap* M_ActivityFishingCeleLotteryMap::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityFishingCeleLotteryMap());
	}
	return msSingleton.get();
}

void M_ActivityFishingCeleLotteryMap::Release()
{
	msSingleton.reset(nullptr);
}
